###########################################################################
#
#  html2sml.tag
#
#  This is a configuration file for html2text that implements
#  html2sml, which translates HTML to some valid SML/NG.
#
#  The format of this file is perl code.  See the html2text file for
#  more details on its contents.
#
###########################################################################
#
#  Update History:
#
#  who     when		what
#  -----  --------     ------------------------------------------
#  dpvc	   10/95	Wrote it.
#  nancy   07/2001	Changed it. 
#

#
#  The initialization string for when there are images to be
#  processed.

$htmlInitialStringPS= "";

#
#  The initialization string for when there are no images
#
$htmlInitialStringNoPS = "";

#
#  The termination string for the output file
#
$htmlFinalString = "";

#
#  Load the common TeX information
#

######################################################################
### The following used to be the file    html2tex-common.tag   #######
######################################################################
###########################################################################
#
#  html2tex-common.tag
#
#  The format of this file is perl code.  See the html2latex file for
#  more details on its contents.
#
###########################################################################
#
#  Update History:
#
#  who     when		what
#  -----  --------     ------------------------------------------
#  dpvc	   10/95	Wrote it.
#  schaefer 3/98        Added the file to html2latex.tag


#
#  The default extension for output files.
#
$htmlExtension = ".sml";

#
#  How to output "<" and "&".
#
$htmlLtString = '';
$htmlAmpString = '';

#
#  Allow line breaks at "\" and "{", and put a "%" at the and of a
#  line when it breaks at one of these places.
#
$htmlBreakChars = '\\\{';
$htmlBreakNL = "%";


#
#  Some characters need to be treated specially.  We output the TeX
#  codes for typesetting these.
#
$htmlChar{"\$"} = '$';    ###LINE110
$htmlChar{"\#"} = '#';
$htmlChar{"{"} = '{';
$htmlChar{"}"} = '}';
$htmlChar{"%"} = '%';
$htmlChar{"_"} = '_';
$htmlChar{">"} = ' ';
$htmlChar{"|"} = '';
$htmlChar{"~"} = ' ';
$htmlChar{"^"} = ' ';
$htmlChar{"\\"} = ' ';
$htmlChar{'"'} = ' ';
# $htmlChar{"\xa0"} = '|';
# $htmlChar{"\xa9"} = 'c';
# $htmlChar{"\xe9"} = 'e';
# $htmlChar{"\xe8"} = 'e';



#
#  The entities need to be converted to TeX format.
#  Some do not have TeX equivalents, and are left blank.
#
$htmlEntity{"amp"} = 'amp';
$htmlEntity{"lt"} = 'lt';
$htmlEntity{"gt"} = 'gt';
$htmlEntity{"nbsp"} = 'nbsp';

$htmlEntity{"iexcl"} = ' ';
$htmlEntity{"cent"} = ' ';
$htmlEntity{"pound"} = 'pound';
$htmlEntity{"curren"} = 'current';
$htmlEntity{"yen"} = '';
$htmlEntity{"brvbar"} = '';
$htmlEntity{"brkbar"} = '';
$htmlEntity{"sect"} = '';
$htmlEntity{"uml"} = '';
$htmlEntity{"copy"} = '';
$htmlEntity{"ordf"} = '';
$htmlEntity{"laquo"} = '';
$htmlEntity{"not"} = '';
$htmlEntity{"shy"} = '';
$htmlEntity{"reg"} = '';
$htmlEntity{"hibar"} = '';
$htmlEntity{"deg"} = '';
$htmlEntity{"plusmn"} = '';
$htmlEntity{"sup2"} = '';
$htmlEntity{"sup3"} = '';
$htmlEntity{"acute"} = '';
$htmlEntity{"micro"} = '';
$htmlEntity{"para"} = '';
$htmlEntity{"middot"} = '';
$htmlEntity{"cedil"} = '';
$htmlEntity{"sup1"} = '';
$htmlEntity{"ordm"} = '';
$htmlEntity{"raquo"} = '';
$htmlEntity{"frac14"} = '';
$htmlEntity{"frac12"} = '';
$htmlEntity{"frac34"} = '';
$htmlEntity{"iquest"} = '';
$htmlEntity{"Agrave"} = '';
$htmlEntity{"Aacute"} = '';
$htmlEntity{"Acirc"} = '';
$htmlEntity{"Atilde"} = '';
$htmlEntity{"Auml"} = '';
$htmlEntity{"Aring"} = '';
$htmlEntity{"AElig"} = '';
$htmlEntity{"Ccedil"} = '';
$htmlEntity{"Egrave"} = '';
$htmlEntity{"Eacute"} = '';
$htmlEntity{"Ecirc"} = '';
$htmlEntity{"Euml"} = '';
$htmlEntity{"Igrave"} = '';
$htmlEntity{"Iacute"} = '';
$htmlEntity{"Icurc"} = '';
$htmlEntity{"Iuml"} = '';
$htmlEntity{"ETH"} = '';
$htmlEntity{"Dstrok"} = '';
$htmlEntity{"Ntilde"} = '';
$htmlEntity{"Ograve"} = '';
$htmlEntity{"Oacute"} = '';
$htmlEntity{"Ocirc"} = '';
$htmlEntity{"Otilde"} = '';
$htmlEntity{"Ouml"} = '';
$htmlEntity{"times"} = '';
$htmlEntity{"Oslash"} = '';
$htmlEntity{"Ugrave"} = '';
$htmlEntity{"Uacute"} = '';
$htmlEntity{"Ucirc"} = '';
$htmlEntity{"Uuml"} = '';
$htmlEntity{"Yacute"} = '';
$htmlEntity{"THORN"} = '';
$htmlEntity{"szlig"} = '';
$htmlEntity{"agrave"} = '\`a';
$htmlEntity{"aacute"} = "\\'a";
$htmlEntity{"acirc"} = '\^a';
$htmlEntity{"atilde"} = '\~a';
$htmlEntity{"auml"} = '\"a';
$htmlEntity{"aring"} = '{\aa}';
$htmlEntity{"aelig"} = '{\ae}';
$htmlEntity{"ccedil"} = '{\c c}';
$htmlEntity{"egrave"} = '\`e';
$htmlEntity{"eacute"} = "\\'e";
$htmlEntity{"ecirc"} = '\^e';
$htmlEntity{"euml"} = '\"e';
$htmlEntity{"igrave"} = '{\`\i}';
$htmlEntity{"iacute"} = "{\\'\\i}";
$htmlEntity{"icirc"} = '{\^\i}';
$htmlEntity{"iuml"} = '{\"\i}';
$htmlEntity{"eth"} = '';
$htmlEntity{"ntilde"} = '\~n';
$htmlEntity{"ograve"} = '\`o';
$htmlEntity{"oacute"} = "\\'o";
$htmlEntity{"ocirc"} = '\^o';
$htmlEntity{"otilde"} = '\~o';
$htmlEntity{"ouml"} = '\"o';
$htmlEntity{"divide"} = '';
$htmlEntity{"oslash"} = '{\o}';
$htmlEntity{"ugrave"} = '\`u';
$htmlEntity{"uacute"} = "\\'u";
$htmlEntity{"ucirc"} = '\^u';
$htmlEntity{"uuml"} = '\"u';
$htmlEntity{"yacute"} = "\\'y";
$htmlEntity{"thorn"} = '';
$htmlEntity{"yuml"} = '\"y';
$htmlEntity{"quot"} = '';


#
#  Define the different character styles
#
$htmlTag{"B"} = '<B>'; $htmlTag{"/B"} = '</B>';
$htmlTag{"I"} = '<I>'; $htmlTag{"/I"} = '</I>';
$htmlTag{"U"} = '<U>'; $htmlTag{"/U"} = '</U>';
$htmlTag{"TT"} = '<TT> '; $htmlTag{"/TT"} = '</TT>';
$htmlTag{"EM"} = '<EM> '; $htmlTag{"/EM"} = '</EM>';
$htmlTag{"STRONG"} = '<S> '; $htmlTag{"/STRONG"} = '</S>';
$htmlTag{"CODE"} = '<b><TT><3> '; $htmlTag{"/CODE"} = '</3></TT></b>';
$htmlTag{"SAMP"} = '<U><r><TT> '; $htmlTag{"/SAMP"} = '</U></r></TT>';
$htmlTag{"CITE"} = '<B><c>'; $htmlTag{"/CITE"} = '</c></B>';
$htmlTag{"KBD"} = '<TT><m> '; $htmlTag{"/KBD"} = '</m></TT>';
$htmlTag{"VAR"} = '<r></I> '; $htmlTag{"/VAR"} = '</I></r>';
$htmlTag{"DFN"} = '<0>'; $htmlTag{"/DFN"} = '</0>';
$htmlTag{"ADDRESS"} = "<4><U><U>"; $htmlTag{"/ADDRESS"} = "</U></U></4>";

#
#  Use special macros for <BR> and <HR>
#
$htmlTag{"BR"} = "\n";
$htmlTag{"HR"} = "\n";

#
#  Handle FORMs correctly
#
$htmlTag{"INPUT"} = '&htmlInput';
$htmlTag{"SELECT"} = '&htmlSelect';
$htmlTag{"/SELECT"} = '&htmlSelectEnd';
$htmlTag{"OPTION"} = '&htmlOption';
$htmlTag{"TEXTAREA"} = '&htmlTextarea';
$htmlTag{"/TEXTAREA"} = '&htmlTextareaEnd';

#
#  Handle quotes specially:  put out the correct set depending on
#  whether this is an open or a close quote.
#  11/21/97 schaefer -- We only do this if we are not in PRE mode.
sub htmlQuote
{
    if ($htmlPreMode) {&htmlPrint(q/"/)}
    else {
	if ($htmlQuoteOpen) {&htmlPrint(q/''/)} else {&htmlPrint(q/``/)}
	$htmlQuoteOpen = !$htmlQuoteOpen;
    }
}


#
#  Process comments specially:
#  If the command begins with "\TeX" then the rest of the comment is
#  inserted into the tex output verbatim (this provides a method of
#  embedding TeX commands in the HTML file but not having them mess up
#  the look when it is viewed on the web).
#
$htmlComment = "&htmlTeXcomment";
sub htmlTeXcomment
{
  local ($comment) = @_;
  if ($comment =~ m/^\\TeX +/i) {&htmlPrint($')}
}

#  This second comment handler adds the ability to turn off the html output
#  when it is convenient to replace it with the TeX commands.
#  Turn off with <!--SUSPENDinTeX-->
#  Turn back on with <!--RESUMEinTeX-->
#  10-31-97 J. Schaefer

sub htmlTeXcommentWithSuspend
{
  local ($comment) = @_;
  if ($comment =~ m/^\\TeX +/i) {&htmlPrint($')}
  if ($comment =~ m/^SUSPENDinTeX/i) {&htmlSuspendOutput}
  if ($comment =~ m/^RESUMEinTeX/i) {&htmlRestoreOutput}
}

#
#  &htmlNewLine  - conditionally print a newline
#
#  If there is some text one the current line
#    End the current line with a "%"
#    Make sure that leading spaces are retained
#
sub htmlNewLine
{
  if ($htmlLinePar eq 0)
  {
    &htmlPrint($htmlBreakNL."\n");
    $htmlLineSpace = -1;
  }
}


######################################################################
#
#  Routines to handle FORMs
#


#
#  &htmlInputCHECK  - process a check box
#
#  Output \htmlInputCheckbox with the correct checked status.
#
sub htmlInputCHECKBOX
{
  &htmlPrint("<c>checkbox</c>");
}

#
#  &htmlInputRADIO  - process a radio button
#
#  Output \htmlInputRadio with the correct checked status.
#
sub htmlInputRADIO
{
  &htmlPrint("<r>radio</r>");
}

#
#  &htmlInputSUBMIT  - process a submit button
#
#  Output \htmlINputButton with the correct button name (translating
#  any entities within the button name).
#
sub htmlInputSUBMIT
{
  &htmlPrint("<S>submit</S>");
}

#
#  &htmlInputRESET  - process a reset button
#
#  Output \htmlINputButton with the correct button name (translating
#  any entities within the button name).
#
sub htmlInputRESET
{
  &htmlPrint("<R>reset</R>");
}

#
#  &htmlInputBUTTON  - process a reset button
#
#  Output \htmlInputButton with the correct button name (translating
#  any entities within the button name).
#
sub htmlInputBUTTON
{
  &htmlPrint(" <I>Input </I> ");
}

#
#  &htmlInputTEXT  - process a single-line text entry field
#
#  Get the size and default text.
#  If the size has both a row and column value (obsolete HTML)
#    Split the size into its parts
#    Start a multi-column input area
#    Send out the text in PRE-formatted mode
#    End the text area
#  Otherwise
#    Output \htmlInputText withthe correct size and text (translating
#    any entities in the default text).
#
sub htmlInputTEXT
{
    &htmlPrint("<TT>TextArea</TT>");
}

#
#  &htmlInputIMAGE  - process a selectable image
#
#  If we're in Postscript mode
#    Make sure this is marked as an ISMAP item and do the PS image
#  Otherwise do a regular text image
#
sub htmlInputIMAGE
{
  &htmlTextIMG
}

#
#  &htmlTextarea  - process a multi-line text area
#
#  Parse the tags and get the ROWS and COLS items
#  Print a new line, if needed
#  Output the \htmlTextarea command with the correct size
#  Start PRE-formatted mode
#
sub htmlTextarea
{
  &htmlPrint("<TT>TextArea</TT>");
  $htmlPreMode++;
}
#
#  End PRE-formatted mode
#  End the text area
#
sub htmlTextareaEnd
{
  $htmlPreMode-- if ($htmlPreMode);
  &htmlPrint("<I>end of text<r>area</r></I>");
}

#
#  &htmlSelect  - process a single- or multi-line menu selection
#
#  Parse the tags and look for the SIZE item
#  Split it into rows and columns (or just columns if only one is suplied)
#  If this is a single line item
#    Suspend output until the selected <OPTION> is found
#  Otherwise
#    Start a new line if needed
#    Start a multi-line menu in PRE-formatted mode
#
sub htmlSelect
{
    &htmlPrint("begin select");
    $htmlPreMode++;
}

#
#  &htmlSelectEnd  - end a single-or multi-line menu
#
#  If this was a multi-line menu
#    End PRE_formatted mode and end the menu
#  Otherwise
#    If the output is suspended, restore it
#    Otherwise (we're in the selected <OPTION>) end the option text
#
sub htmlSelectEnd
{
  if ($htmlPreMode)
  {
    $htmlPreMode--;
    &htmlPrint("end select");
  } else {
    if ($htmlNoOutput) {&htmlRestoreOutput} else {&htmlPrint("}")}
  }
}

#
#  &htmlOption  - process a menu option
#
#  Parse the tags
#  If this is part of a multi-line menu
#    If the item is selected, output the select bullet
#    Otherwise output some blank spaces
#  Otherwise (single-line menu)
#    If the item is selected
#      Restore the output so the selected item will show up
#      Output the \htmlInputMenu macro (the menu name will follow)
#    Otherwise if the previous option was the selected on
#      Close the text string for it and suspend the output again
#
sub htmlOption
{
   &htmlPrint("blab");
}


######################################################################
######## End of the file    html2tex-common.tag        ###############
######################################################################


#
#  Define the list tags
#
$htmlTag{"UL"} = "\n\n<U>itemize\n";
$htmlTag{"/UL"} = "\n</U>\n\n";
$htmlTag{"OL"} = "\n\n<U>enumerate\n";
$htmlTag{"/OL"} = "\n</U>\n\n";
$htmlTag{"LI"} = "\nitem ";
$htmlTag{"DL"} = '&htmlDL'; $htmlTag{"/DL"} = '&htmlDLend';
$htmlTag{"DT"} = '&htmlDT';
$htmlTag{"DD"} = '&htmlDD';

#
#  To process definition lists, we record whether a DT is currently in
#  effect.  If a DD occurs without a preceeding DT, then we use the
#  special \htmlDD macro, otherwise just use a paragraph break
#
$htmlDTopen = 0;
sub htmlDL {&htmlPrint("\n\n<B>description\n"); $htmlDTopen = 0}
sub htmlDLend {&htmlPrint("\n</B>\n\n")}
sub htmlDT {&htmlPrint("\n\ITEM "); $htmlDTopen = 1}
sub htmlDD
{
  if ($htmlDTopen) {&htmlPrint("\n\n")} else {&htmlPrint("\n ")}
  $htmlDTopen = 1;
}


#
#  Define the special formatiing tags
#
$htmlTag{"BLOCKQUOTE"} = "\n\nbegin{quote}\n";
$htmlTag{"/BLOCKQUOTE"} = "\nend{quote}\n\n";
$htmlTag{"PRE"} = '&htmlPRE';
$htmlTag{"/PRE"} = '&htmlPREend';

#
#  Print out the macros for PRE mode, and make sure the text between
#  them preserves its line breaks and spacing
#
sub htmlPRE {&htmlPrint("\n\n<TT>\n"); $htmlPreMode = 1}
sub htmlPREend {$htmlPreMode = 0; &htmlPrint("\n</TT>\n\n")}


#
#  Define the heading classes
#
$htmlTag{"H1"} = "\n\n<S>";       
$htmlTag{"/H1"} = "</S>\n\n";
$htmlTag{"H2"} = "\n\n<S><U>";    
$htmlTag{"/H2"} = "</U></S>\n\n";
$htmlTag{"H3"} = "\n\n<S><U> <U>"; 
$htmlTag{"/H3"} = " </U> </U> </S>\n\n";
$htmlTag{"H4"} = "\n\n<EM> <U>";     
$htmlTag{"/H4"} = "<S> </S> </U> <b> h4 </b></EM>\n\n";
$htmlTag{"H5"} = "\n\n<EM> <r>";         
$htmlTag{"/H5"} = "</r> </EM>\n\n";
$htmlTag{"H6"} = "\n\n<EM> <b><U>";    
$htmlTag{"/H6"} = "</U></b></EM>\n\n";

$htmlTag{"A"} = "<S>ANCHOR</S>"; $htmlTag{"/A"} = "\n\n";

#
# Load new tags for later versions of HTML
#
######################################################################
### The following used to be the file    newh2latex.tag        #######
######################################################################

#&htmlRequire("newh2latex");

#  This tag file for html2latex that allows the use of new tags 
#  not found in the original version.
#
#  6/25/97  schaefer  First draft of TABLE, TR, TD tags.
#  6/23/97  schaefer  Added CENTER tags.
#  3/25/98  schaefer  Added to the file html2latex.tag
#
#  It's not clear why this works, so I will comment it out for now.
#  This inserts an extra special character which
#  will allow the backslashes to be replaced correctly
#  Only when using this, single \'s are replaced with {\htmlBackslash} as
#  expected.
#
  $htmlChar{"\\\\"} = '{\jeffsBack}';


#
$htmlTag{"CENTER"} = "\ncenter\n";
$htmlTag{"/CENTER"} = "\ncenter\n";

# The BIG and SMALL tags will be changed to fixed sizes for now.
# Ideally, they should increase/decrease the size further when nested.
#
$htmlTag{"BIG"} = "<9>";     $htmlTag{"/BIG"} = "</9>";
$htmlTag{"SMALL"} = "<0>";     $htmlTag{"/SMALL"} = "</0>";

# A really long subscript may cause problems, since LaTeX will not break a 
# line in the middle of a subscript (even if there are spaces).
# 
$htmlTag{"SUB"} = "<r><1>";     $htmlTag{"/SUB"} = "</1></r>";
$htmlTag{"SUP"} = "<c><1>";     $htmlTag{"/SUP"} = "</1></c>";

# Underlining also does not work across line breaks, so instead we
# change to italics.
#
$htmlTag{"U"} = "<U>";     $htmlTag{"/U"} = "</U>";

# It is not clear yet what to do with the STRIKE tag
#   Alternatives are: Don't print anything
#                     Print with tiny letters or alternate font
#                     Use a different color (light gray)
#
#$htmlTag{"STRIKE"} = "???";     $htmlTag{"/STRIKE"} = "???";

#
#  Tags for Tables
#
$htmlTag{"TABLE"} = ""; 	# ignore
$htmlTag{"/TABLE"} = "";
$htmlTag{"TR"} = "";
$htmlTag{"TD"} = "";
$htmlTag{"TH"} = "";
# The optional /TR, /TH, and /TD tags are ignored.
$htmlTag{"CAPTION"} = "";


######################################################################
########   END of the file newh2latex.tag    #########################
######################################################################

1;  # make sure perl sees an OK return status
